#!/bin/sh
# -*-Scheme-*-
#
# Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
#     2016, 2017, 2018, 2019 Matthew Birkholz
#
# This file is part of a Gtk screen plugin for MIT/GNU Scheme Pucked.
#
# This plugin is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This plugin is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this plugin; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301, USA.

# Test the gtk-screen option.

set -e
: ${MIT_SCHEME_EXE=mit-scheme}
${MIT_SCHEME_EXE} --prepend-library . --batch-mode <<\EOF
(begin
  (load-option 'gtk-screen)

  (if (gtk-initialized?)
      (let ((env (->environment '(gtk gtk-widget))))
	(spawn-edit)
	(let loop ()
	  (sleep-current-thread 1000)
	  (if (not (null? (access toplevel-windows env)))
	      (loop)))
	(gc-flip)
	(sleep-current-thread 100)		;Ensure GC deamons finish?
	(let ((ffi (->environment '(runtime ffi))))
	  (if (not (zero? (car ((access registered-callback-count ffi)))))
	      (error "Gtk-Screen did not clean up its callbacks"))
	  (if (not (null? (access malloced-aliens ffi)))
	      (error "Gtk-Screen did not free allocated memory;"
		     (map (lambda (elt)
			    (let ((alien (weak-car elt)))
			      (if (eq? 'uchar (alien/ctype alien))
				  (c-peek-cstring alien)
				  alien)))
			  (access malloced-aliens ffi))))))
      (warn "Could not test the gtk-screen option without a DISPLAY."))
  )
EOF
